/// <reference types="react" />
import { FormProps } from './types';
/**
 * `Form` wrapper based on `Form` from the [`react-final-form`](https://github.com/final-form/react-final-form). That accept [`FormProps`](https://github.com/final-form/react-final-form#formprops) props and some extra props for easy working with 8base API.
 * @prop {string} [tableSchemaName] - The name of the 8base API table schema.
 * @prop {string} [appName] - The name of the 8base API application.
 */
declare const Form: {
    ({ type, tableSchemaName, appName, formatRelationToIds, ignoreNonTableFields, ignorePristineValues, beforeFormatDataForMutation, afterFormatDataForMutation, beforeFormatQueryData, afterFormatQueryData, onSuccess, ...props }: FormProps<any>): JSX.Element;
    defaultProps: {
        ignoreNonTableFields: boolean;
        ignorePristineValues: boolean;
        mutators: {};
    };
};
export { Form };
//# sourceMappingURL=Form.d.ts.map